<!DOCTYPE html>
<html lang="en" dir="ltr">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <title>Exercise project - S'NCE GROUP</title>

    <link rel="stylesheet" href="/assets/css/bootstrap.min.css?v=4.4.1">

  </head>
  <body>

    <div class="d-flex flex-column flex-md-row align-items-center p-3 px-md-4 mb-3 bg-white border-bottom shadow-sm">
      <h5 class="my-0 mr-md-auto font-weight-normal">Poke project</h5>
      <nav class="my-2 my-md-0 mr-md-3">
        <a class="p-2 text-dark" href="/team/list">Home <small>(list)</small></a>
        <a class="p-2 text-dark" href="/team/create">New Team</a>
      </nav>
    </div>

    <div class="container">
      <div id="contentapp">
        <!-- dynamic content -->
      </div>
    </div>

    <footer class="pt-4 my-md-5 pt-md-5 border-top">
      <div class="row">
        <div class="col-12 col-md pl-5">
            <small>Author: ddzz | created for: S'NCE GROUP</small>
        </div>
      </div>
    </footer>

<script type="text/template" id="team-list">
  <div class="content">
    <h2>Teams List</h2>
    <div class="col-12 form-inline">
      Filter type:
      <select class="ml-5 custom-select">
        <option value="*">All</option>
      </select>
    </div>
    <div class="row">
      <div class="col-12">
        <table class="table">
          <thead>
            <tr>
              <th scope="col">Team name</th>
              <th scope="col">pokemon list</th>
              <th scope="col">Total experience</th>
              <th scope="col">All types</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
    </div>
  </div>
</script>

<script type="text/template" id="team-box">
  <div class="card">
    <h5 class="card-header"> Team box </h5>
    <div class="card-body">
      <div class="card-title">Team Name:
        <div class="input-group mb-3">
          <input name="team-name" class="form-control" placeholder=".. my team" />
          <div class="input-group-append"><button class="btn input-group-text">OK</button></div>
        </div>
      </div>
      <p class="card-text">Add pokemon into team:</p>
      <button class="btn btn-primary" disabled="disabled">Gotta Catch 'Em All</button>
      <hr />
      <ul class="list-group list-group-flush" id="list-poke">

      </ul>
    </div>
  </div>
</script>

    <!-- js library loads -->
    <script type="text/javascript" src="/assets/js/jquery-3.4.1.min.js"></script>
    <script type="text/javascript" src="/assets/js/app.js"></script>
    <!-- page management  -->
    <script type="text/javascript">
      $(function(){
        console.log('start', location.href)

        // ############  routes management ###################
        // create
        if(location.href.indexOf('create') != -1 || location.href.indexOf('edit') != -1){
          // -------------------------------------------create / update
        $('#contentapp').html( $('#team-box').html()).find('input')
          .on('change', function(){
            const self = this
            if(this.value.length == 0) return
            $(this).attr('readonly', true)
            myApp.create_team($(this).val()).done(function(res){
              $(self).closest('.card-body').find('button')
                     .removeAttr('disabled')
                     .data('id',res.id)
            })
        })

        $('#contentapp').find('button.btn-primary').on('click',function(e){
          var self = this
          e.preventDefault()
          var txt = $(this).text()
          $(this).text('it\'s searching... please wait').attr('disabled',true)
          myApp.discover_pokemon($(this).data('id')).done(function(res){
            myApp.add_poke_list($('#list-poke'), res.data);
            $(self).text(txt).attr('disabled',false)
          })
        })

        if(location.href.indexOf('edit') != -1){
            // -------------------------------------------edit
            //$('#contentapp').html( $('#team-box').html()).find()
            var id_team = location.href.replace(/(.*)(team\/)(\d+)(\/edit)/,'$3')
            myApp.get_team(id_team).done(function(res){
              res.data.pokemon.forEach(p=>{ myApp.add_poke_list($('#list-poke'), p, true); })
              $('#contentapp .card-body>button').removeAttr('disabled').data('id',id_team)
              $('#contentapp input').val(res.data.name).attr('readonly', true)
              $('#list-poke button').on('click', function(){
                myApp.liberates_poke(id_team, $(this).val()).then(res=>{
                  if(res.success) $(this).parent().remove()
                })
              })
            })
        }
      }else{
          // -------------------------------------------list (default)
          $('#contentapp').html( $('#team-list').html())
          myApp.get_list().done(function(e){
            $('#contentapp table>tbody').append(
              myApp.list_row(e.data)
            )
            e.data.reduce((aa,o)=>([...aa,...o.pokemon.reduce((a,p)=>([...a,...p.types]),[])]),[])
              .filter((v, i, a) => a.indexOf(v) === i)
              .forEach(function(i){
                $('#contentapp select').append(`<option value="${i}">${i}</option>`)
              })
              $('#contentapp select').on('change', function(){
                var filter = $(this).val()
                if(filter=='*')
                  $('#contentapp table>tbody>tr').each(function(){ $(this).show() })
                else
                  $('#contentapp table>tbody>tr').filter(function(){
                    return $(this).is(`:not(:contains('${filter}'))`)
                  }).each(function(){ $(this).hide() })

                });

          })
      }

      })
    </script>

  </body>
</html>
